local IncAbsorb = ShadowUF.modules["incAbsorb"]

function IncAbsorb:OnLayoutApplied(frame)
	if( not frame.visibility[self.frameKey] or not frame.visibility.healthBar ) then return end

	if( frame.visibility.healAbsorb ) then
		frame:RegisterUnitEvent("UNIT_HEAL_ABSORB_AMOUNT_CHANGED", self, "UpdateFrame")
	else
		frame:UnregisterSingleEvent("UNIT_HEAL_ABSORB_AMOUNT_CHANGED", self, "UpdateFrame")
	end
	
	self:LayoutBar(frame)
end

-- New absorption bar is made here
function IncAbsorb:LayoutBar(frame)
	local bar = frame[self.frameKey]
	local cap = ShadowUF.db.profile.units[frame.unitType][self.frameKey].cap or 1.30
	
	bar.total = nil

	-- Sets size and theme
	bar:SetSize(frame.healthBar:GetSize())
	bar:SetStatusBarTexture(ShadowUF.Layout.mediaPath.statusbar)
	bar:SetStatusBarColor(ShadowUF.db.profile.healthColors[self.colorKey].r, ShadowUF.db.profile.healthColors[self.colorKey].g, ShadowUF.db.profile.healthColors[self.colorKey].b, ShadowUF.db.profile.bars.alpha)
	bar:GetStatusBarTexture():SetHorizTile(false)
	bar:SetOrientation(frame.healthBar:GetOrientation())
	bar:SetReverseFill(frame.healthBar:GetReverseFill())
	
	bar:Hide()
	
	
	bar.simple = true
	bar:SetFrameLevel(frame.topFrameLevel + self.frameLevelMod)

	bar:ClearAllPoints()
	
	local absorb_height = 0.3	-- <- Change  these to set new height
	local absorb_width  = 0.2	--
	
	
	if( bar:GetOrientation() == "HORIZONTAL" ) then
		bar:SetWidth(frame.healthBar:GetWidth() * cap)
		bar:SetPoint("TOP"   , frame.healthBar, "BOTTOM", 0, absorb_height * frame.healthBar:GetHeight())
		bar:SetPoint("BOTTOM", frame.healthBar)
		if(frame.healthBar:GetReverseFill()) then
			bar:SetPoint("RIGHT",frame.healthBar)
		else
			bar:SetPoint("LEFT", frame.healthBar)
		end
	else
		bar:SetHeight(frame.healthBar:GetHeight() * cap)
		bar:SetPoint("RIGHT", frame.healthBar, "LEFT", absorb_width * frame.healthBar:GetWidth(), 0)
		bar:SetPoint("LEFT" , frame.healthBar)
		if(frame.healthBar:GetReverseFill()) then
			bar:SetPoint("TOP",frame.healthBar)
		else
			bar:SetPoint("BOTTOM", frame.healthBar)
		end
	end	
end

function IncAbsorb:PositionBar(frame, incAmount)
	local bar = frame[self.frameKey]
	local health = UnitHealth(frame.unit)
	
	incAmount = UnitGetTotalAbsorbs(frame.unit) or 0

	local health = UnitHealth(frame.unit)
	if( health <= 0 or incAmount <= 0 ) then
		bar.total = nil
		bar:Hide()
		return
	end

	if( not bar.total ) then 
		bar:Show() 
	end
	
	bar.total = incAmount

	bar:SetMinMaxValues(0, UnitHealthMax(frame.unit) * (ShadowUF.db.profile.units[frame.unitType][self.frameKey].cap or 1.30))
	bar:SetValue(bar.total)
end


